 
from algopy import zeros, dot, sin

class Kronecker(object):
    
    def __init__(self):
        
        self.type_of_DAE='linear'
        self.example_name='Kronecker_linear'
        
    def eval_A(self,t):
        """ some function """
        n=5
        A = zeros((n,n),dtype=t)
        A[0,0]=1.
        A[1,2]=1.
        A[2,3]=1.
        A[3,4]=1.
        return A
    
    
    def eval_B(self,t):
        n=5
        B = zeros((n,n),dtype=t)
        B[0,0]=1.
        B[1,1]=1.
        B[2,2]=1.
        B[3,3]=1.
        B[4,4]=1.
        return B

    def f(self,y,x,t):
        """ DAE in linear_example2 """
        n=5   
        f = zeros(n, dtype=x)
        q=zeros(n,dtype=t)
        q[4]=sin(t)
        f=dot(self.eval_A(t), y) + dot(self.eval_B(t), x) -q
        return f

if __name__=="__main__":    
  
    from numpy import array,pi
    from DAEinitialization.consistentValues import consistentValuesIndex
    ex = Kronecker()
    
    n=5
    K = 10
    
    t0=pi/4
    alpha=array([1.,1.,1.,1.,1.])
    
    print 'Solution by minimization'
    print 'alpha = ',alpha
    ftola=1e-14
    x0=zeros(K*n)
    x0[:n]=alpha
    solution,index,cond,robust=consistentValuesIndex(ex,K,alpha,x0,t0,ftol=ftola,disp=True,info_level=2)
    