 
from algopy import zeros, sin

class Kronecker(object):
    
    def __init__(self):
        
        self.type_of_DAE='proper'
        self.example_name='Kronecker_proper'

    def f(self,dp,x,t):
        """ DAE in linear_example2 """
        n=5
        f = zeros(n, dtype=x)
        
        f[0]=dp[0]+x[0]
        f[1]=dp[1]+x[1]
        f[2]=dp[2]+x[2]
        f[3]=dp[3]+x[3]
        f[4]= x[4]-sin(t)
       
        return f
    
    def d(self,x,t):
        d = zeros(4, dtype=x)
        d[0]=x[0]
        d[1]=x[2]
        d[2]=x[3]
        d[3]=x[4]
        return d
    
#     def u(self,x):
#         """
#         ux contains requirements for the initial values
#         """
#         ux=zeros(1, dtype=x)
#         ux[0]=x[0]-0.5
#         return ux

if __name__=="__main__":    
  
    from numpy import array,pi
    from DAEinitialization.consistentValues import consistentValuesIndex  
    ex = Kronecker()
    
    n=5
    K = 10
    
    t0=pi/4
    alpha=array([1.,1.,1.,1.,1.])
    
    print 'Solution by minimization'
    print 'alpha = ',alpha
 
    ftola=1e-14
    x0=zeros(K*n)
    x0[:n]=alpha
    solution,index,cond,robust=consistentValuesIndex(ex,K,alpha,x0,t0,ftol=ftola,info_level=2,disp=True)
    