
'''
Created on 27.03.2014

@author: lamour
'''

from algopy import zeros

class Example_ind2_singAt_t_0(object):

    def __init__(self):
        """
        example from
        Estevez Schwarz, D. and Lamour, R.(2014), Towards an AD based diagnosis of singularities of DAEs. Proc. Appl. Math. Mech., 14: 867-868. doi:10.1002/pamm.201410414        """
        self.example_name='Example_ind2_singAt_t_0'
        self.type_of_DAE='proper'
          
    def f(self,y,x,t):
        """ DAE index 2 with singularity at t=0"""
        f = zeros(3, dtype=x)
        f[0]=y[0]+x[2]
        f[1]=y[1]+x[0]+t*x[2]/4
        f[2]=x[1]-1.0
        
        return f
    
    def d(self,x,t):
        """ DAE index 2 with singularity at t=0""" 
    
        d = zeros(2, dtype=x)
        d[0:2]=x[0:2]
        return d
    
if __name__=="__main__":   
    from numpy import array
    from DAEinitialization.consistentValues import consistentValuesIndex
    ex = Example_ind2_singAt_t_0()
    
    n=3
    K = 6
    
    t0=1.#0.
    alpha=array([1.,1.,1.])
    
    print 'Solution by minimization'
 
    print 'alpha = ',alpha
    ftola=1e-14
    x0=zeros(K*n)
    x0[:n]=alpha
    solution,index,cond,robust=consistentValuesIndex(ex,K,alpha,x0,t0,ftol=ftola,info_level=3,disp=True)